"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Creator = exports.truncatePubkey = exports.WUMBO_TWITTER_TLD = exports.WUMBO_TWITTER_VERIFIER = void 0;
const react_1 = require("@chakra-ui/react");
const web3_js_1 = require("@solana/web3.js");
const useGovernance_1 = require("../hooks/useGovernance");
const react_2 = __importDefault(require("react"));
const react_router_dom_1 = require("react-router-dom");
const hooks_1 = require("../hooks");
const nameService_1 = require("../hooks/nameService");
exports.WUMBO_TWITTER_VERIFIER = new web3_js_1.PublicKey("DTok7pfUzNeNPqU3Q6foySCezPQE82eRyhX1HdhVNLVC");
exports.WUMBO_TWITTER_TLD = new web3_js_1.PublicKey("Fhqd3ostRQQE65hzoA7xFMgT9kge2qPnsTNAKuL2yrnx");
const truncatePubkey = (pkey) => {
    const pkeyStr = pkey.toString();
    return `${pkeyStr.substr(0, 4)}...${pkeyStr.substr(pkeyStr.length - 4)}`;
};
exports.truncatePubkey = truncatePubkey;
exports.Creator = react_2.default.memo(({ creator, getCreatorLink, }) => {
    const { handleErrors } = (0, hooks_1.useErrorHandler)();
    const { metadata, tokenRef, error, image } = (0, hooks_1.useSocialTokenMetadata)(creator);
    const { nameString: handle, error: reverseTwitterError2 } = (0, nameService_1.useReverseName)(creator, exports.WUMBO_TWITTER_VERIFIER, exports.WUMBO_TWITTER_TLD);
    handleErrors(error, reverseTwitterError2);
    const { info: governance } = (0, useGovernance_1.useGovernance)(creator);
    const children = (react_2.default.createElement(react_2.default.Fragment, null,
        metadata && (react_2.default.createElement(react_1.HStack, { spacing: 1 },
            react_2.default.createElement(react_1.Avatar, { size: "xs", src: image }),
            react_2.default.createElement(react_1.Text, null, metadata.data.name))),
        !metadata && !handle && (0, exports.truncatePubkey)(creator),
        !metadata && handle && `@${handle}`));
    if (governance) {
        react_2.default.createElement(react_router_dom_1.Link, { to: `https://realms.today/dao/${governance.realm.toBase58()}` }, children);
    }
    // @ts-ignore
    const link = getCreatorLink(creator, metadata, tokenRef, handle);
    if (link.includes("http")) {
        return (react_2.default.createElement(react_1.Link, { ml: "1", mr: "1", href: link }, children));
    }
    return react_2.default.createElement(react_router_dom_1.Link, { to: link }, children);
});
//# sourceMappingURL=Creator.js.map